/*
 *
 */
package org.softevo.ample.sibrelib.runtime;

import java.util.HashMap;

import org.apache.commons.lang.IntHashMap;

/**
 * @author dallmeier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ClassSequenceWriter extends SequenceWriter {

  protected static IntHashMap classTraceMap = null;
  
  protected static class ShutdownThread extends Thread {
    
    protected PatternNameWriter patternNameWriter;
    
    public ShutdownThread(PatternNameWriter patternNameWriter) {
      super();
      this.patternNameWriter = patternNameWriter;
    }
    
    public void run() {
      System.out.println("Before adding underful: " + classToPatternSetMap.size());
      addUnderfullWindows();
      System.out.println("After adding underful: " + classToPatternSetMap.size());
      writeResults(classToPatternSetMap, patternNameWriter);
    }
  }

  protected static void addUnderfullWindows() {
    int[] classIds, instanceIds, traceWindow, copy;
    IntHashMap instanceMap;
    Pattern pattern, oldPattern;
    int size;
    HashMap patternMap;
    
    if (windowSize > 1) {
      classIds = classTraceMap.getKeys();
      for (int counter = 0; counter < classIds.length; counter++) {
        traceWindow = (int[]) classTraceMap.get(classIds[counter]);
        for (size = 0; size < traceWindow.length; size++) {
          if (traceWindow[size] == -1) {
            break;
          }
        }
        if (size < windowSize) {
          copy = new int[size];
          for (int copyCounter = 0; copyCounter < size; copyCounter++) {
            copy[copyCounter] = traceWindow[copyCounter];
          }
          pattern = new Pattern();
          pattern.pattern = copy;
          pattern.discoveryIndex = entryCounter;
          pattern.lastOccurence = entryCounter;
          patternMap = getOrCreatePatternSet(classIds[counter]);
          oldPattern = (Pattern) patternMap.get(pattern);
          if (oldPattern != null) {
            oldPattern.occurences++;
          } else {
            patternMap.put(pattern,pattern);
          }
        }
      }
    }
  }


  
}
