/*
 *
 */
package org.softevo.ample.sibrelib.runtime;

import java.util.Properties;


public class Options {

  public static final String KEY_OUTPUTFILENAME = "outputfile";

  public static final String KEY_IDENTITYMAPFILENAME = "identityMap";
  
  public static final String KEY_WINDOWSIZE = "windowsize";
  
  private static Properties properties;
  
  public static String getProperty(String key) {
    return properties.getProperty(key);
  }
  
  public static String getOutputFileName() {
    return properties.getProperty(KEY_OUTPUTFILENAME);
  }
  
  public static String getIdentityMapFileName() {
    return properties.getProperty(KEY_IDENTITYMAPFILENAME);
  }
  
  public static int getWindowSize() {
    return Integer.parseInt(properties.getProperty(KEY_WINDOWSIZE));
  }
  
  static {
    properties = new Properties();
    properties.put("outputfile", "wurst");
  }
}
