/*
 *
 */
package org.softevo.ample.sibrelib.runtime;

import java.util.HashMap;

import org.apache.commons.lang.IntHashMap;
import org.softevo.ample.sibrelib.runtime.SequenceWriter.PatternNameWriter;

/**
 * @author dallmeier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ObjectSequenceWriter extends SequenceWriter {

  protected static IntHashMap classToInstanceMapMap = null;
  
  /** Gets the trace map for a class. <BR>
   *  If none exists in the map, a new instance
   *  is created.
   */
  protected static IntHashMap getOrCreateInstanceTraceMap(int classId) {
    IntHashMap result;
    
    result = (IntHashMap) classToInstanceMapMap.get(classId);
    if (result == null) {
      result = new IntHashMap(100);
      classToInstanceMapMap.put(classId, result);
    }
    return result;
  }
  
  protected static void addUnderfullWindows() {
    int[] classIds, instanceIds, traceWindow, copy;
    IntHashMap instanceMap;
    Pattern pattern, oldPattern;
    int size;
    HashMap patternMap;
    
    if (windowSize > 1) {
      classIds = classToInstanceMapMap.getKeys();
      for (int counter = 0; counter < classIds.length; counter++) {
        instanceMap = (IntHashMap) classToInstanceMapMap.get(classIds[counter]);
        instanceIds = instanceMap.getKeys();
        for (int counter2 = 0; counter2 < instanceIds.length; counter2++) {
          traceWindow = (int[]) instanceMap.get(instanceIds[counter2]);
          for (size = 0; size < traceWindow.length; size++) {
            if (traceWindow[size] == -1) {
              break;
            }
          }
          if (size < windowSize) {
            copy = new int[size];
            for (int copyCounter = 0; copyCounter < size; copyCounter++) {
              copy[copyCounter] = traceWindow[copyCounter];
            }
            pattern = new Pattern();
            pattern.pattern = copy;
            pattern.discoveryIndex = entryCounter;
            pattern.lastOccurence = entryCounter;
            patternMap = getOrCreatePatternSet(classIds[counter]);
            oldPattern = (Pattern) patternMap.get(pattern);
            if (oldPattern != null) {
              oldPattern.occurences++;
            } else {
              System.out.println("Adding ununderfull pattern " + pattern);
              patternMap.put(pattern,pattern);
            }
          }
        }
      }
    }
  }

  protected static class ShutdownThread extends Thread {
    
    protected PatternNameWriter patternNameWriter;
    
    public ShutdownThread(PatternNameWriter patternNameWriter) {
      super();
      this.patternNameWriter = patternNameWriter;
    }
    
    public void run() {
      System.out.println("Before adding underful: " + classToPatternSetMap.size());
      addUnderfullWindows();
      System.out.println("After adding underful: " + classToPatternSetMap.size());
      writeResults(classToPatternSetMap, patternNameWriter);
    }
  }
  
}
